## unattended-upgrades 1.1ubuntu1.18.04.7~16.04.4+8.0trisquel2

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.7~16.04.4+8.0trisquel2) flidas; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 07 Nov 2019 17:10:29 +0000

unattended-upgrades (1.1ubuntu1.18.04.7~16.04.4) xenial; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 18 Oct 2019 13:29:41 +0200

## unattended-upgrades 1.1ubuntu1.18.04.7~16.04.6

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.7~16.04.6) xenial; urgency=medium

  * data/50unattended-upgrades.Ubuntu: add new ESM repositories (LP: #1857051)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 17 Feb 2020 12:39:28 +0100

unattended-upgrades (1.1ubuntu1.18.04.7~16.04.5) xenial; urgency=medium

  * Fix non-minimal upgrades (LP: #1853861)
    - Mark packages for performing non-minimal upgrades
    - Clear cache after checking upgrades against the blacklist again.
      This fixes the issue when the dirty cache caused all packages to be
      upgraded in the first "minimal" step.
      Thanks to Paul Wise
    - Leave the cache clean when returning from calculate_upgradable_pkgs()
      When collecting upgradable packages the upgradable ones stayed in the
      cache and they were upgraded together even when unattended-upgrades
      was configured to perform upgrades in minimal steps.
      Thanks to Paul Wise
    - Clear cache after downloading packages

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Nov 2019 16:23:06 +0100

## unattended-upgrades 1.1ubuntu1.18.04.7~16.04.7

=== test/Makefile ===
#!/usr/bin/make

all: check

test-packages:
	$(MAKE) -C packages

check: test-packages
	# test with both py2 and py3 for now and also use coverage for the py2
	set -e; \
	find . -name 'test_*.py' | \
	while read file; do \
	    if [ -x $$file ]; then \
		echo "Running $$file with python3"; \
	    	python3 $$file 2>&1; \
		echo "Running $$file with python"; \
		python-coverage run -a $$file 2>&1; \
	    fi \
	done

clean:
	$(MAKE) -C packages clean
	rm -rf ./aptroot/var/cache/
	rm -rf ./aptroot/var/lib/apt
	rm -rf ./aptroot/var/run
	find .. -type d -name __pycache__ | xargs rm -rf

coverage-html:
	echo "output in htmlcov/
	python-coverage html

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.7~16.04.7) xenial; urgency=medium

  * data: add md5sum history file on the data folder (LP: #1915547)
    - This file contains the md5sum of the current xenial and trusty
      version of 50unattended-upgrades. This file will be used to avoid
      prompting users about unattended-upgrade changes when upgrading
      from trusty to xenial.
  * debian/postint: make ucf command reference the md5sum history file

 -- Lucas Moura <lucas.moura@canonical.com>  Wed, 10 Feb 2021 17:37:18 -0300

=== debian/control ===
Source: unattended-upgrades
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Michael Vogt <mvo@debian.org>
Uploaders: Balint Reczey <rbalint@ubuntu.com>
Section: admin
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 9~),
               equivs,
               gir1.2-glib-2.0,
               po-debconf,
               python,
               python-gi,
               python3,
               python3-dbus,
               python3-distutils-extra,
               python3-gi,
               python3-setuptools
Build-Depends-Indep: python-dev,
                     python3-dev,
                     python-coverage,
                     pep8,
                     pyflakes,
                     python-apt,
#                    powermgmt-base, (tests disable on_ac_power checks)
                     python3-apt,
                     python-mock,
                     python3-mock,
                     lsb-release,
                     dh-systemd
Standards-Version: 3.9.3
Vcs-Git: https://github.com/mvo5/unattended-upgrades.git

Package: unattended-upgrades
Architecture: all
Depends: ${shlibs:Depends},
         ${misc:Depends},
         debconf,
         gir1.2-glib-2.0,
         powermgmt-base,
         python3,
         python3-apt,
         python3-gi,
         python3-dbus,
         ucf,
         lsb-release,
         lsb-base,
         xz-utils
Recommends: cron | cron-daemon | anacron
Suggests: bsd-mailx,
          default-mta | mail-transport-agent,
          needrestart
Description: automatic installation of security upgrades
 This package can download and install security upgrades automatically
 and unattended, taking care to only install packages from the
 configured APT source, and checking for dpkg prompts about
 configuration file changes.
 .
 This script is the backend for the APT::Periodic::Unattended-Upgrade
 option.

=== debian/rules ===
#!/usr/bin/make -f

PYTHON=python3
DIST=$(shell dpkg-vendor --query Vendor)

%:
	dh $@ --with=systemd

override_dh_auto_build:
	# copy the right template into place
	cp data/50unattended-upgrades.$(DIST) data/50unattended-upgrades
	$(PYTHON) setup.py build

override_dh_auto_test:
	$(MAKE) -C test

override_dh_auto_install:
	$(PYTHON) setup.py install \
		--root=$(CURDIR)/debian/unattended-upgrades \
		--install-layout=deb

override_dh_installinit:
	# We do not want to run the init script in the postinst/prerm, its
	# really only useful on shutdown, see Debian bug #645919.
	dh_installinit -r --no-start

override_dh_auto_clean:
	# Sanity-check before upload.
	set -e; for f in unattended-upgrade unattended-upgrade-shutdown; do \
		ln -nsf $$f $$f.py; \
		py3compile $$f.py; \
	        pycompile $$f.py; \
		rm -f $$f.py; \
	done
	$(PYTHON) setup.py clean -a
	rm -rf .coverage \
		test/.coverage \
		test/.mypy_cache \
		test/root.*/var/cache/apt/*.bin \
		test/root.*/var/log \
		test/root.unused-deps/var/cache/apt/archives/lock \
		test/root.unused-deps/var/lib/apt/extended_states \
		test/root.unused-deps/var/lib/dpkg/status \
		test/root.unused-deps/var/run/unattended-upgrades.progress \
		test/u-u.lock

=== debian/tests/control ===
Tests: run-tests test-systemd.py
Depends: @, @builddeps@
Restrictions: needs-root, isolation-container, needs-reboot

Tests: upgrade-all-security
Depends: @, @builddeps@, debootstrap, distro-info
Restrictions: needs-root, build-needed

Tests: upgrade-between-snapshots
Depends: @, @builddeps@, debootstrap
Restrictions: needs-root, build-needed, flaky

## unattended-upgrades 1.1ubuntu1.18.04.7~16.04.7%2B8.0trisquel2

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.7~16.04.7+8.0trisquel2) flidas; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 25 Mar 2021 13:06:45 +0000

## unattended-upgrades 1.1ubuntu1.18.04.12+9.0trisquel2

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.12+9.0trisquel2) etiona; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 16 Nov 2019 01:01:00 +0000

unattended-upgrades (1.1ubuntu1.18.04.12) bionic; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 18 Oct 2019 13:24:28 +0200

unattended-upgrades (1.1ubuntu1.18.04.11) bionic; urgency=medium

  * Detect changes to moved conffiles (LP: #1823872)
    - Add tests for checking conffile moves.
      Build depend on and use equivs to generate new test packages
    - Split() conffile data to set of names only once
    - Don't parse dpkg conffile db when there are no conffiles in the package
  * Detect unchanged moved conffiles.
    When a package moves a conffile properly without any change no conffile
    prompt needs to be shown thus the package can be upgraded unattended.
    (LP: #1823872)
  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)
  * Make sure autoremovals don't start with a dirty cache and remove other
    packages (LP: #1824341)
  * Continue applying minimal sets when one set can't be marked for upgrade.
    Thanks to Anderson Luiz Alves for the patch, it needed minor modifications
    (LP: #1824341)
  * Stop raising NoAllowedOriginError when marking packages to upgrade/install
    fails (LP: #1824876)
  * Adjust only transitive dependencies in the fallback when a package from an
    allowed origin can't be marked to install/upgrade.
    This is a much lighter approach than marking every upgradable package
    because the full fallback was triggered on packages held back as well,
    using an excessive amount of CPU time.
    Also it crashed with packages not having any version in allowed origins.
    (LP: #1824804, #1824949)
  * Skip trying to upgrade held packages in call_adjusted() (LP: #1824804)
  * Follow all kinds of transitive dependencies when adjusting dependencies
  * Don't crash collecting transitive dependencies when package has no candidate
    (LP: #1825886)
  * Use mark_install_adjusted() in rewind_cache()
    The original cache had packages marked with adjustments thus rewinding
    should also do adjustments to reach the same state.
    Also not using mark_install_adjusted() crashes when apt raises error on
    held packages. (LP: #1826157)
    - test_rewind: Update test to check if adjustend rewinding took place

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 29 Apr 2019 12:13:14 +0200

unattended-upgrades (1.1ubuntu1.18.04.10) bionic; urgency=medium

  * do_auto_remove() is successful unless a commit() operation fails
    (LP: #1795696)
  * Compare apt.package.Version objects and not the versions' string
    representation. (LP: #1820888)
    This prevented adjusting candidates when the strings sorted differently.
    Also extend tests to catch issue.
  * Fall back to adjusting more packages' candidates
    when a package from an allowed origin can't be marked to install/upgrade.
    (LP: #1821101)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Mar 2019 18:17:56 +0100

unattended-upgrades (1.1ubuntu1.18.04.9) bionic; urgency=medium

  * debian/changlog: Drop extra trailer after old entry
  * Don't check blacklist too early and report updates from not allowed origins
    as kept back. (LP: #1781176)
  * test/test_blacklisted_wrong_origin.py: Fix and enable test
  * Clear cache when autoremoval fails (LP: #1779157)
  * Find autoremovable kernel packages using the patterns in APT's way
    (LP: #1815494)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 21 Feb 2019 14:58:38 +0100

unattended-upgrades (1.1ubuntu1.18.04.8) bionic; urgency=medium

  * Start service after systemd-logind.service to be able to take inhibition
    lock (LP: #1806487)
  * Handle gracefully when logind is down (LP: #1806487)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 13 Dec 2018 14:42:44 +0100

## unattended-upgrades 1.1ubuntu1.18.04.14

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.14) bionic; urgency=medium

  * data/50unattended-upgrades.Ubuntu: add new ESM repositories (LP: #1857051)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 17 Feb 2020 12:37:03 +0100

unattended-upgrades (1.1ubuntu1.18.04.13) bionic; urgency=medium

  * Fix non-minimal upgrades (LP: #1853861)
    - Mark packages for performing non-minimal upgrades
    - Clear cache after checking upgrades against the blacklist again.
      This fixes the issue when the dirty cache caused all packages to be
      upgraded in the first "minimal" step.
      Thanks to Paul Wise
    - Leave the cache clean when returning from calculate_upgradable_pkgs()
      When collecting upgradable packages the upgradable ones stayed in the
      cache and they were upgraded together even when unattended-upgrades
      was configured to perform upgrades in minimal steps.
      Thanks to Paul Wise
    - Clear cache after downloading packages

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Nov 2019 16:23:06 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Section: admin
 Testsuite: autopkgtest
 Priority: optional
-Build-Depends: debhelper (>= 9~),
+Build-Depends: debhelper (>= 9.20160709),
                equivs,
                gir1.2-glib-2.0,
                po-debconf,
@@ -26,8 +26,7 @@
                      python3-apt,
                      python-mock,
                      python3-mock,
-                     lsb-release,
-                     dh-systemd
+                     lsb-release
 Standards-Version: 3.9.3
 Vcs-Git: https://github.com/mvo5/unattended-upgrades.git

## unattended-upgrades 1.1ubuntu1.18.04.14+9.0trisquel2

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.14+9.0trisquel2) etiona; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 28 Feb 2020 22:15:52 +0000

## unattended-upgrades 1.1ubuntu1.18.04.14+9.0trisquel4

=== debian/changelog ===
unattended-upgrades (1.1ubuntu1.18.04.14+9.0trisquel4) etiona; urgency=medium

  * Compiled for Trisquel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 28 May 2022 02:00:59 +0000

## unattended-upgrades 1.5ubuntu3

=== debian/changelog ===
unattended-upgrades (1.5ubuntu3) cosmic; urgency=medium

  * Skip already adjusted packages from being checked for readjusting.
    This makes it clearer that the recursion ends and can also be a bit quicker.
    (LP: #1790687)
  * Fix PEP 8 warnings.
    Also ignore "W503 line break before binary operator" because it will
    become the best practice.
  * Don't crash on missing dpkg log file (LP: #1795692)
  * do_auto_remove() is successful unless a commit() operation fails
    (LP: #1795696)
  * Check only dowloaded .deb files for conffile prompts (LP: #1796100)

 -- Balint Reczey <rbalint@ubuntu.com>  Sun, 07 Oct 2018 23:16:17 +0200

unattended-upgrades (1.5ubuntu2) cosmic; urgency=medium

  * Reopen Cache after commit() even when frontend locking is supported.
    This fixes build and operation with latest python-apt.

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 28 Aug 2018 15:46:25 +0200

unattended-upgrades (1.5ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable
    - Remaining changes:
      - unattended-upgrades: Do not automatically upgrade the development
        release of Ubuntu unless Unattended-Upgrade::DevRelease is true.
    - Dropped changes, included in Debian:
      - Redirect stderr output in upgrade-all-security and
        upgrade-between-snapshots otherwise it breaks the test
      - Skip rebuilding python-apt in upgrade autopkgtests

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 23 Aug 2018 11:02:51 +0200

unattended-upgrades (1.5) unstable; urgency=medium

  * Redirect stderr output in upgrade-all-security and upgrade-between-snapshots
    otherwise it breaks the test (LP: #1781446)
  * Skip rebuilding python-apt in upgrade autopkgtests.
    Python-apt has a new build dependency making the rebuilding as is failing
    and the reference handling issue is worked around in unattended-upgrades
    already. (LP: #1781586)
  * Install release's latest python-apt in upgrade-all-security
  * Don't check blacklist too early and report updates from not allowed origins as kept back.
    This fixes #116 again that was fixed but regressed with 18d23402aae24febb6bda539ac7c410fd86ae80d
    (LP: #1781176)
  * Run unattended-upgrades.service before shutdown.target as a oneshot service.
    Performing upgrades in service's ExecStop did not work when the upgrades
    involved restarting services because systemd blocked other stop/start actions
    making maintainer scripts time out and be killed leaving a broken system
    behind. (LP: #1778219)
  * Use os.environ[] to set debconf to NON_INTERACTIVE instead of os.putenv()
    os.putenv() does not change os.environ but os.environ can be used in python-apt
    to set environment for subprocesses in which case os.putenv()'s effect is
    ignored.
  * Use valgrind in upgrade autopkgtest when it is installed in the autopkgtest environment
  * Stop trying when no adjustment could be made and adjust package candidates only to lower versions
    (LP: #1785093)
  * List Unattended-Upgrade::Remove-New-Unused-Dependencies option the config file.
    Also fix description of Unattended-Upgrade::Remove-Unused-Dependencies.

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 23 Aug 2018 09:40:13 +0200

unattended-upgrades (1.4ubuntu2) cosmic; urgency=medium

  * Redirect stderr output in upgrade-all-security and
    upgrade-between-snapshots otherwise it breaks the test (LP: #1781446)
  * Skip rebuilding python-apt in upgrade autopkgtests.
    Python-apt has a new build dependency making the rebuilding as is failing
    and the reference handling issue is worked around in unattended-upgrades
    already, install release's latest python-apt in upgrade-all-security
    instead (LP: #1781586)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 13 Jul 2018 17:08:54 +0200

unattended-upgrades (1.4ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable
    - Remaining changes:
      - unattended-upgrades: Do not automatically upgrade the development
        release of Ubuntu unless Unattended-Upgrade::DevRelease is true.
    - Dropped changes, included in Debian:
      - Stop rewriting test apt.conf in test_untrusted.py.
      - Fix test_on_battery on Ubuntu development releases

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 06 Jul 2018 13:33:29 +0200

unattended-upgrades (1.4) unstable; urgency=medium

  * Skip starting init.d script in debhelper-generated postinst part
    (LP: #1778800)
  * Use "deb-systemd-invoke start" instead of "systemctl start" in postinst.
    It is used only in a workaround applied for a Debian bug and for upgrading
    from pre-bionic versions.
  * Clear cache when autoremoval is invalid for a package set marked for
    removal (LP: #1779157)
  * Clear cache after failed commits to return from a possibly invalid state
  * Unlock for dpkg operations with apt_pkg.pkgsystem_unlock_inner() when it
    is available, also stop running when reacquiring the lock fails.
    Thanks to to Julian Andres Klode for original partial patch
  * Use fully qualified domain name in email subject.
  * Send email about all failures and crashes (Closes: #898607)
  * Add short textual summary of the results in the summary email
  * Recommend overriding configuration in a separate file.
    This can be better than changing /etc/apt/apt.conf.d/50unattended-upgrades
    because package updates don't conflict with local changes this way.
  * Adjust candidates only for packages to be possibly installed
    (Closes: #892028, #899366) (LP: #1396787)
  * Add Unattended-Upgrade::OnlyOnACPower config file example for all
    distributions
  * debian/control: Drop redundant Testsuite: autopkgtest field to keep Lintian
    happy
  * Bump Standards-Version to 4.1.4
  * Add debian/tests/upgrade-all-security to install all current security
    updates. On development releases this tests latest stable, on stable
    releases it tests the release itself.
  * Skip updates on metered connections (Closes: #855570)
  * Quote shell variables in autopkgtest


=== debian/control ===
--- 
+++ 
@@ -3,31 +3,23 @@
 XSBC-Original-Maintainer: Michael Vogt <mvo@debian.org>
 Uploaders: Balint Reczey <rbalint@ubuntu.com>
 Section: admin
-Testsuite: autopkgtest
 Priority: optional
 Build-Depends: debhelper (>= 9.20160709),
-               equivs,
                gir1.2-glib-2.0,
                po-debconf,
-               python,
-               python-gi,
                python3,
-               python3-dbus,
                python3-distutils-extra,
                python3-gi,
                python3-setuptools
-Build-Depends-Indep: python-dev,
-                     python3-dev,
-                     python-coverage,
+Build-Depends-Indep: python3-dev,
+                     python3-coverage,
                      pep8,
-                     pyflakes,
-                     python-apt,
 #                    powermgmt-base, (tests disable on_ac_power checks)
+                     pyflakes3,
                      python3-apt,
-                     python-mock,
                      python3-mock,
                      lsb-release
-Standards-Version: 3.9.3
+Standards-Version: 4.1.4
 Vcs-Git: https://github.com/mvo5/unattended-upgrades.git
 
 Package: unattended-upgrades
@@ -40,7 +32,6 @@
          python3,
          python3-apt,
          python3-gi,
-         python3-dbus,
          ucf,
          lsb-release,
          lsb-base,

## unattended-upgrades 1.5ubuntu3.18.10.4

=== debian/changelog ===
unattended-upgrades (1.5ubuntu3.18.10.4) cosmic; urgency=medium

  * Detect changes to moved conffiles (LP: #1823872)
  * Add tests for checking conffile moves.
    Build depend on and use equivs to generate new test packages
  * Detect unchanged moved conffiles.
    When a package moves a conffile properly without any change no conffile
    prompt needs to be shown thus the package can be upgraded unattended.
    (LP: #1823872)
    - Split() conffile data to set of names only once
    - Don't parse dpkg conffile db when there are no conffiles in the package
  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)
  * Make sure autoremovals don't start with a dirty cache and remove other
    packages (LP: #1824341)
  * Continue applying minimal sets when one set can't be marked for upgrade.
    Thanks to Anderson Luiz Alves for the patch, it needed minor modifications
    (LP: #1824341)
  * Stop raising NoAllowedOriginError when marking packages to upgrade/install
    fails (LP: #1824876)
  * Adjust only transitive dependencies in the fallback when a package from an
    allowed origin can't be marked to install/upgrade.
    This is a much lighter approach than marking every upgradable package
    because the full fallback was triggered on packages held back as well,
    using an excessive amount of CPU time.
    Also it crashed with packages not having any version in allowed origins.
    (LP: #1824804, #1824949)
    - Follow all kinds of transitive dependencies when adjusting dependencies
    - Don't crash collecting transitive dependencies when package has no
      candidate (LP: #1825886)
  * Skip trying to upgrade held packages in call_adjusted() (LP: #1824804)
  * Use mark_install_adjusted() in rewind_cache()
    The original cache had packages marked with adjustments thus rewinding
    should also do adjustments to reach the same state.
    Also not using mark_install_adjusted() crashes when apt raises error on
    held packages. (LP: #1826157)
    - test_rewind: Update test to check if adjustend rewinding took place

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 26 Apr 2019 18:55:30 +0200

unattended-upgrades (1.5ubuntu3.18.10.3) cosmic; urgency=medium

  * Compare apt.package.Version objects and not the versions' string
    representation. (LP: #1820888)
    This prevented adjusting candidates when the strings sorted differently.
    Also extend tests to catch issue.
  * Fall back to adjusting more packages' candidates
    when a package from an allowed origin can't be marked to install/upgrade.
    (LP: #1821101)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 25 Mar 2019 17:10:19 +0100

unattended-upgrades (1.5ubuntu3.18.10.2) cosmic; urgency=medium

  * Clear cache when autoremoval fails (LP: #1779157)
  * Find autoremovable kernel packages using the patterns in APT's way
    (LP: #1815494)
  * Filter out progress indicator from dpkg log (LP: #1599646)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 21 Feb 2019 15:10:13 +0100

unattended-upgrades (1.5ubuntu3.18.10.1) cosmic; urgency=medium

  * Start service after systemd-logind.service to be able to take inhibition
    lock (LP: #1806487)
  * Handle gracefully when logind is down (LP: #1806487)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 13 Dec 2018 14:39:12 +0100

unattended-upgrades (1.5ubuntu3.18.10.0) cosmic; urgency=medium

  * Revert to running unattended-upgrades.service in multi-user.target
  * Trigger unattended-upgrade-shutdown actions with PrepareForShutdown()
    Performing upgrades in service's ExecStop did not work when the upgrades
    involved restarting services because systemd blocked other stop/start
    actions making maintainer scripts time out and be killed leaving a broken
    system behind.
    Running unattended-upgrades.service before shutdown.target as a oneshot
    service made it run after unmounting filesystems and scheduling services
    properly on shutdown is a complex problem and adding more services to the
    mix make it even more fragile.
    The solution of monitoring PrepareForShutdown() signal from DBus
    allows Unattended Upgrade to run _before_ the jobs related to shutdown are
    queued thus package upgrades can safely restart services without
    risking causing deadlocks or breaking part of the shutdown actions.
    Also ask running unattended-upgrades to stop when shutdown starts even in
    InstallOnShutdown mode and refactor most of unattended-upgrade-shutdown to
    UnattendedUpgradesShutdown class. (LP: #1778219, LP: #1803137)
  * Handle reverting to WantedBy=multi-user.target
  * Increase logind's InhibitDelayMaxSec to 30s.
    This allows more time for unattended-upgrades to shut down gracefully
    or even install a few packages in InstallOnShutdown mode, but is still a
    big step back from the 30 minutes allowed for InstallOnShutdown previously.
    Users enabling InstallOnShutdown mode are advised to increase
    InhibitDelayMaxSec even further possibly to 30 minutes.
  * Cache polling result for PreparingForShutdown after it becomes true
  * debian/tests/test-systemd.py: Reboot system with dbus call to honor
    inhibitor locks
  * Add NEWS entry about increasing InhibitDelayMaxSec and InstallOnShutdown
    changes
  * Stop using ActionGroups, they interfere with apt.Cache.clear()
    causing all autoremovable packages to be handled as newly autoremovable ones
    and be removed by default. Dropping ActionGroup usage does not slow down the
    most frequent case of not having anything to upgrade and when ther are
    packages to upgrade the gain is small compared to the actual package
    installation.
    Also collect autoremovable packages before adjusting candidates because that
    also changed .is_auto_removable attribute of some of them. (LP: #1803749)
    (Closes: #910874)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 26 Nov 2018 12:28:55 +0100

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,11 @@
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9.20160709),
+               equivs,
                gir1.2-glib-2.0,
                po-debconf,
                python3,
+               python3-dbus,
                python3-distutils-extra,
                python3-gi,
                python3-setuptools
@@ -32,6 +34,7 @@
          python3,
          python3-apt,
          python3-gi,
+         python3-dbus,
          ucf,
          lsb-release,
          lsb-base,

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,6 @@
 	set -e; for f in unattended-upgrade unattended-upgrade-shutdown; do \
 		ln -nsf $$f $$f.py; \
 		py3compile $$f.py; \
-	        pycompile $$f.py; \
 		rm -f $$f.py; \
 	done
 	$(PYTHON) setup.py clean -a

## unattended-upgrades 1.10ubuntu5

=== debian/changelog ===
unattended-upgrades (1.10ubuntu5) disco; urgency=medium

  * Adjust only transitive dependencies in the fallback
    when a package from an allowed origin can't be marked to install/upgrade.
    This is a much lighter approach than marking every upgradable package because
    the full fallback was triggered on packages held back as well, using an
    excessive amount of CPU time.
    Also it crashed with packages not having any version in allowed origins.
    (LP: #1824804, #1824949)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 16 Apr 2019 08:54:49 +0200

unattended-upgrades (1.10ubuntu4) disco; urgency=medium

  * Make sure autoremovals don't start with a dirty cache and remove other
    packages (LP: #1824341)
  * Continue applying minimal sets when one set can't be marked for upgrade.
    Thanks to Anderson Luiz Alves for the patch, it needed minor modifications
    (LP: #1824341)
  * Stop raising NoAllowedOriginError when marking packages to upgrade/install
    fails (LP: #1824876)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 16 Apr 2019 00:01:56 +0200

unattended-upgrades (1.10ubuntu3) disco; urgency=medium

  * Detect changes to moved conffiles (LP: #1823872)
  * Add tests for checking conffile moves.
    Build depend on and use equivs to generate new test packages

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 11 Apr 2019 22:48:00 +0200

unattended-upgrades (1.10ubuntu2) disco; urgency=medium

  * Compare apt.package.Version objects and not the versions' string
    representation. (LP: #1820888)
    This prevented adjusting candidates when the strings sorted differently.
    Also extend tests to catch issue.
  * Fall back to adjusting more packages' candidates
    when a package from an allowed origin can't be marked to install/upgrade.
    (LP: #1821101)
  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 22 Mar 2019 20:42:08 +0100

unattended-upgrades (1.10ubuntu1) disco; urgency=medium

  * Use defaults in unattended-upgrades.service when the APT configuration is
    broken. (LP: #1815189)
  * test/test_blacklisted_wrong_origin.py: Fix and enable test
  * Clear cache when autoremoval fails (LP: #1779157)
  * Find autoremovable kernel packages using the patterns in APT's way
    (LP: #1815494)
  * debian/rules: clean frontend locks left by tests before building source

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 18 Feb 2019 17:26:05 +0100

unattended-upgrades (1.10) unstable; urgency=medium

  * autopkgtest: Check if upgrading in minimal steps is the default
  * Comment out example blacklist item that slipped in to the default config
  * Don't print error on empty /var/run/reboot-required.pkgs
  * Fix filtering out dpkg progress indicator (LP: #1599646) (Closes: #919407)
  * Clear cache after checking upgrades against the blacklist again.
    This fixes the issue when the dirty cache caused all packages to be
    upgraded in the first "minimal" step.
    Thanks to Paul Wise
  * Populate cache for the fetcher after calculate_upgradable_pkgs() left it
    clean. Otherwise the packages are downloaded later skipping the conffile
    tests and possibly failing in a package installation step due to changed
    config files. (Closes: #918323)
  * Fix non-minimal upgrades

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 28 Jan 2019 21:35:26 +0700

unattended-upgrades (1.9) unstable; urgency=medium

  [ Julian Andres Klode ]
  * test_dev_release: Fix and enable test.
  * Depend on python3-distro-info.
    This is needed to make sure DEVEL_UNTIL_RELEASE actually works. We need
    to fix up travis in addition to control, as it only knows about trusty
    build dependencies.
  * Import distro_info globally, and fix calculation of days.
    The check was off by one: If you were 21 days away from the release,
    it would not switch on, but tell you that it would not upgrade before
    today.
  * test_dev_release: Test Unattended-Upgrade::DevRelease=auto.

  [ David Lang and Balint Reczey]
  * Allow installing untrusted packages when APT::Get::AllowUnauthenticated
    is set (Closes: #775469) (LP: #1167053)

  [ Hans van Kranenburg and Balint Reczey]
  * Clarify highly misleading Package-Blacklist option documentation
    (Closes: #753892)

  [ Balint Reczey ]
  * test/test_dev_release.py: Fix missing mock attributes
  * Leave the cache clean when returning from calculate_upgradable_pkgs()
    When collecting upgradable packages the upgradable ones stayed in the
    cache and they were upgraded together even when unattended-upgrades
    was configured to perform upgrades in minimal steps.
    Thanks to Paul Wise
  * debian/tests/upgrade-all-security: Check if all security-updates are
    applied and if old-autoremovable packages are kept
  * Clear cache only when needed when checking black- and whitelists
  * Add --no-minimal-upgrade-steps option
  * Stop using untrusted package names as blacklists (LP: #1805447)
  * Update copyright info
  * Load modules lazily loaded by datetime.datetime.strptime() when u-u starts
    When Python is upgraded to a new major version the version running
    unattended-upgrades can be removed as being newly unused causing a crash.
  * Start service after systemd-logind.service to be able to take inhibition
    lock and handle gracefully when logind is down (LP: #1806487)
  * List packages making reboot required in /var/run/reboot-required.pkgs

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 12 Dec 2018 13:41:49 +0100

unattended-upgrades (1.8) unstable; urgency=medium

  * Add note about increasing InhibitDelayMaxSec for InstallOnShutdown to
    50unattended-upgrades.
  * Ship historical md5sums of /etc/apt/apt.conf.d/50unattended-upgrades for ucf
  * Remove .ucf-* configuration file copies on purge
  * Add NEWS entry about increasing InhibitDelayMaxSec and InstallOnShutdown
    changes


=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Priority: optional
 Build-Depends: debhelper (>= 9.20160709),
                equivs,
-               gir1.2-glib-2.0,
                po-debconf,
                python3,
                python3-dbus,
@@ -15,7 +14,8 @@
                python3-setuptools
 Build-Depends-Indep: python3-dev,
                      python3-coverage,
-                     pep8,
+                     python3-distro-info,
+                     pycodestyle | pep8,
 #                    powermgmt-base, (tests disable on_ac_power checks)
                      pyflakes3,
                      python3-apt,
@@ -29,20 +29,20 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          debconf,
-         gir1.2-glib-2.0,
-         powermgmt-base,
          python3,
          python3-apt,
-         python3-gi,
          python3-dbus,
+         python3-distro-info,
          ucf,
          lsb-release,
          lsb-base,
          xz-utils
-Recommends: cron | cron-daemon | anacron
+Recommends: systemd-sysv | cron | cron-daemon | anacron
 Suggests: bsd-mailx,
           default-mta | mail-transport-agent,
-          needrestart
+          needrestart,
+          powermgmt-base,
+          python3-gi
 Description: automatic installation of security upgrades
  This package can download and install security upgrades automatically
  and unattended, taking care to only install packages from the

=== debian/tests/control ===
--- 
+++ 
@@ -8,4 +8,4 @@
 
 Tests: upgrade-between-snapshots
 Depends: @, @builddeps@, debootstrap
-Restrictions: needs-root, build-needed, flaky
+Restrictions: needs-root, build-needed

## unattended-upgrades 1.10ubuntu5.2

=== debian/changelog ===
unattended-upgrades (1.10ubuntu5.2) disco; urgency=medium

  * Report packages kept back by origin (LP: #1821376)
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160) (LP: #1823070)
  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 18 Oct 2019 13:22:02 +0200

unattended-upgrades (1.10ubuntu5.1) disco; urgency=medium

  * Skip trying to upgrade held packages in call_adjusted() (LP: #1824804)
  * Follow all kinds of transitive dependencies when adjusting dependencies
    (LP: #1824804)
  * Detect unchanged moved conffiles.
    When a package moves a conffile properly without any change no conffile
    prompt needs to be shown thus the package can be upgraded unattended even
    when the conffile is changed locally. (LP: #1823872)
  * Don't crash collecting transitive dependencies when package has no candidate
    (LP: #1825886)
  * Use mark_install_adjusted() in rewind_cache()
    The original cache had packages marked with adjustments thus rewinding
    should also do adjustments to reach the same state.
    Also not using mark_install_adjusted() crashes when apt raises error on
    held packages. (LP: #1826157)
    - test_rewind: Update test to check if adjusted rewinding took place

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 26 Apr 2019 15:00:50 +0200

## unattended-upgrades 1.11

=== debian/changelog ===
unattended-upgrades (1.11) unstable; urgency=medium

  * Use defaults in unattended-upgrades.service when the APT configuration is
    broken. (LP: #1815189)
  * test/test_blacklisted_wrong_origin.py: Fix and enable test
  * Clear cache when autoremoval fails (LP: #1779157)
  * Find autoremovable kernel packages using the patterns in APT's way
    (LP: #1815494)
  * debian/rules: clean frontend locks left by tests before building source

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 18 Feb 2019 17:26:05 +0100

## unattended-upgrades 1.11.2

=== test/Makefile ===
#!/usr/bin/make

all: check

check:
	set -e; \
	find . -name 'test_*.py' | \
	while read file; do \
	    if [ -x $$file ]; then \
		echo "Running $$file with python3"; \
	    	python3 $$file 2>&1; \
		echo "Running $$file with python3-coverage"; \
		python3 -m coverage run -a $$file 2>&1; \
	    fi \
	done

clean:
	rm -rf ./aptroot/var/cache/
	rm -rf ./aptroot/var/lib/apt
	rm -rf ./aptroot/var/run
	find .. -type d -name __pycache__ | xargs rm -rf

coverage-html:
	echo "output in htmlcov/
	python3 -m coverage html

=== debian/changelog ===
unattended-upgrades (1.11.2) unstable; urgency=medium

  * Test upgrades to -updates and to -proposed in upgrade-all-security autopkgtest.
    Also enable -updates, too, while testing in Debian.
  * Skip upgrade-all-security test when there are no updates to test with.
    Shortly after a release there may not be security updates against the
    packages used in the chroot used for the test.
  * Test with latest stable in upgrade-all-security on testing
  * Fix testing Debian's updates in upgrade-all-security

 -- Balint Reczey <rbalint@ubuntu.com>  Sat, 08 Jun 2019 16:59:45 +0200

unattended-upgrades (1.11.1) unstable; urgency=medium

  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 21 May 2019 09:37:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: unattended-upgrades
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Michael Vogt <mvo@debian.org>
+Maintainer: Michael Vogt <mvo@debian.org>
 Uploaders: Balint Reczey <rbalint@ubuntu.com>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9.20160709),
-               equivs,
                po-debconf,
                python3,
                python3-dbus,

=== debian/rules ===
--- 
+++ 
@@ -36,6 +36,7 @@
 		test/.coverage \
 		test/.mypy_cache \
 		test/root.*/var/cache/apt/*.bin \
+		test/root.*/var/lib/dpkg/lock-frontend \
 		test/root.*/var/log \
 		test/root.unused-deps/var/cache/apt/archives/lock \
 		test/root.unused-deps/var/lib/apt/extended_states \

=== debian/tests/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 Tests: upgrade-all-security
 Depends: @, @builddeps@, debootstrap, distro-info
-Restrictions: needs-root, build-needed
+Restrictions: needs-root, build-needed, skippable
 
 Tests: upgrade-between-snapshots
 Depends: @, @builddeps@, debootstrap

## unattended-upgrades 1.11.2+nmu1

=== debian/changelog ===
unattended-upgrades (1.11.2+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 20:00:19 +0800

## unattended-upgrades 1.14ubuntu1

=== debian/changelog ===
unattended-upgrades (1.14ubuntu1) eoan; urgency=medium

  * autopkgtest: Retry failing downloads a few times
  * test/autopkgtest_kernel_patterns.py: Add debug statements
  * test/autopkgtest_kernel_patterns.py: Use stricter pattern for packages to
    check

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 08 Aug 2019 22:25:47 +0200

unattended-upgrades (1.14) unstable; urgency=medium

  [ Balint Reczey ]
  * Check if md5sums of configuration files are shipped in releases
  * debian/rules: Check duplicate lines in data/50unattended-upgrades.md5sum
  * Use Debian's security updates from $distro-security starting with Bullseye
  * Allow both ${distro_codename} or ${distro_codename}-security on Debian
    as security update codenames. The latter will be used starting with
    Bullseye, but to help backporting and testing the configuration file keeps
    working on Buster and older releases. (Closes: #933138)
  * Default to "/" as rootdir to fix saving list of kept packages.
    Thanks to Paul Wise (Closes: #932160)
  * data/50unattended-upgrades.md5sum: Update for change in Debian's config
  * unattended-upgrade-shutdown: Fix FTBFS due to latest pyflakes' check

  [ Tobias Bannert ]
  * updated german translation

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 07 Aug 2019 17:04:10 +0200

unattended-upgrades (1.13) unstable; urgency=medium

  [ Alban VIDAL ]
  * Update french translation.
    Signed-off-by: Alban VIDAL <alban.vidal@zordhak.fr>

  [ Balint Reczey ]
  * Don't crash collecting transitive dependencies when package has no
    candidate (LP: #1825886)
  * Use mark_install_adjusted() in rewind_cache()
    The original cache had packages marked with adjustments thus rewinding
    should also do adjustments to reach the same state. Not using
    mark_install_adjusted() also crashes when apt raises error on held
    packages. (LP: #1826157)
  * test_rewind: Update test to check if adjustend rewinding took place
  * Only allow removals in valid autoremoval sets
  * Fix one more log location in the man page (Closes: #928601)
  * Factor out kernel regexp generation to functions
  * Packages including kernel version without flavor in their name may be
    kernel packages. Also add autopkgtest for checking if the generated
    patterns cover the currently running kernel. (LP: #1828200)
  * Skip upgrade-all-security test when there are no updates to test with.
    Shortly after a release there may not be security updates against the
    packages used in the chroot used for the test.
  * Test with latest stable in upgrade-all-security on testing
  * Fix testing Debian's updates in upgrade-all-security
  * Store list of kept packages and report the number of them in motd
    (LP: #1823070)
  * Mention APT's apt-daily-upgrade.service in the man page
  * 50unattended-upgrades.md5sum add MD5 of current files
  * PEP8: Fix breaking line after binary operator
  * debian/tests/control: Fix Depends: of upgrade-between-snapshots
  * debian/tests/control: Allow stderr in kernel-patterns

  [ Gordon Lack ]
  * Replace boolean Unattended-Upgrade::MailOnlyOnError2 mail reporting setting
    with multi-valued (string) Unattended-Upgrade::MailReport.

  [ Jaime Hablutzel ]
  * Error message improved on very improbable condition

  [ Clint Armstrong ]
  * Fix showing multi-line strings on Plymouth.
    When unattended-upgrades sends it's status to plymouth it sends a
    multi-line string which causes plymouth to display overlapping text,
    because plymouth only scrolls one line when the message is sent.
    (LP: 1826406)

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 08 Jul 2019 11:08:30 +0200

unattended-upgrades (1.12) experimental; urgency=medium

  [ Brannon Dorsey ]
  * Remove double "format" in 50unattended-upgrades configuration files

  [ Daniel Herzig ]
  * man: improve unattended-upgrade.8 man-page (Closes: #905289)

  [ Jonatan Nyberg ]
  * Swedish debconf strings update (Closes: #925488)

  [ Balint Reczey ]
  * Compare apt.package.Version objects and not the versions' string
    representation. This prevented adjusting candidates when the strings sorted
    differently (LP: #1820888)
  * Enable test_clean and test_patch_days tests
  * Fall back to adjusting more packages' candidates when a package from an
    allowed origin can't be marked to install/upgrade. (LP: #1821101)
  * Skip sending email when no package had to be installed, upgraded or removed
    (LP: #1821103) (Closes: #924554)
  * Add a few debug logging points
  * Report packages kept back by origin (LP: #1821376)
  * Fix trailing newlines in wrapped email lines
  * Describe candidate adjustment fallback better in the debug message
  * Fix missing space. Thanks to Alban VIDAL
  * Update POT file
  * Test upgrades to -updates and to -proposed in upgrade-all-security
    autopkgtest. Also enable -updates, too, while testing in Debian.
  * Add ${distro_id}ESM:${distro_codename}-security to allowed origins
    (LP: #1823376)
  * Detect changes to moved conffiles (LP: #1823872)
  * Add tests for checking conffile moves.
    Build depend on and use equivs to generate new test packages
  * Make sure autoremovals don't start with a dirty cache and remove other
    packages (LP: #1824341)
  * Stop raising NoAllowedOriginError when marking packages to upgrade/install
    fails (LP: #1824876)
  * Continue applying minimal sets when one set can't be marked for upgrade.
    Thanks to Anderson Luiz Alves for the patch, it needed minor modifications
    (LP: #1824341)
  * Skip trying to upgrade held packages in call_adjusted() (LP: #1824804)
  * Adjust only transitive dependencies in the fallback when a package from an
    allowed origin can't be marked to install/upgrade.
    This is a much lighter approach than marking every upgradable package
    because the full fallback was triggered on packages held back as well,
    using an excessive amount of CPU time. (LP: #1824804, #1824949)


=== debian/tests/control ===
--- 
+++ 
@@ -7,5 +7,9 @@
 Restrictions: needs-root, build-needed, skippable
 
 Tests: upgrade-between-snapshots
+Restrictions: needs-root, build-needed
 Depends: @, @builddeps@, debootstrap
-Restrictions: needs-root, build-needed
+
+Tests: kernel-patterns
+Depends: @, @builddeps@
+Restrictions: build-needed, allow-stderr

## unattended-upgrades 1.14ubuntu1.2

=== debian/changelog ===
unattended-upgrades (1.14ubuntu1.2) eoan; urgency=medium

  * data/50unattended-upgrades.Ubuntu: add new ESM repositories (LP: #1857051)
  * Update md5sum of 50unattended-upgrades.Ubuntu

 -- Balint Reczey <rbalint@ubuntu.com>  Mon, 17 Feb 2020 12:29:17 +0100

unattended-upgrades (1.14ubuntu1.1) eoan; urgency=medium

  * debian/tests/control: Mark upgrade-between-snapshots as flaky
    (Closes: #941752) (LP: #1848354)

 -- Balint Reczey <rbalint@ubuntu.com>  Wed, 16 Oct 2019 17:47:42 +0200

=== debian/tests/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Restrictions: needs-root, build-needed, skippable
 
 Tests: upgrade-between-snapshots
-Restrictions: needs-root, build-needed
+Restrictions: needs-root, build-needed, flaky
 Depends: @, @builddeps@, debootstrap
 
 Tests: kernel-patterns
